diff --git a/docs/source/conf.py b/docs/source/conf.py
--- a/docs/source/conf.py
+++ b/docs/source/conf.py
@@ -51,9 +51,9 @@
 # built documents.
 #
 # The short X.Y version.
-version = '0.1.1'
+version = '0.1.2'
 # The full version, including alpha/beta/rc tags.
-release = '0.1.1'
+release = '0.1.2'
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
diff --git a/libtaskotron.spec b/libtaskotron.spec
--- a/libtaskotron.spec
+++ b/libtaskotron.spec
@@ -3,7 +3,7 @@
 %{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:           libtaskotron
-Version:        0.1.1
+Version:        0.1.2
 Release:        1%{?dist}
 Summary:        Taskotron Support Library
 
diff --git a/libtaskotron/__init__.py b/libtaskotron/__init__.py
--- a/libtaskotron/__init__.py
+++ b/libtaskotron/__init__.py
@@ -1 +1 @@
-__version__ = '0.1.1'
+__version__ = '0.1.2'
diff --git a/libtaskotron/directives/yumrepoinfo_directive.py b/libtaskotron/directives/yumrepoinfo_directive.py
--- a/libtaskotron/directives/yumrepoinfo_directive.py
+++ b/libtaskotron/directives/yumrepoinfo_directive.py
@@ -22,7 +22,7 @@
 from libtaskotron import config
 from libtaskotron import yumrepoinfo
 
-from libtaskotron.exceptions import TaskotronDirectiveError, TaskotronValueError
+from libtaskotron.exceptions import TaskotronDirectiveError
 from libtaskotron.logger import log
 
 directive_class = 'YumrepoinfoDirective'
@@ -36,34 +36,30 @@
     and up are returned.
     If the koji_tag is '-pending', the '-pending' is stripped (as it is not
     a repo), and then the code works the same.
-    It is also possible to assing koji_tag to 'rawhide'.
+    It is also possible to assign koji_tag to 'rawhide'.
 
     format: "yumrepoinfo:
                 koji_tag=<tag>
                 arch=<arch>
     """
 
     def __init__(self, repoinfo = None):
-        self.conf = config.get_config()
-        if repoinfo is not None:
-            self.repoinfo = repoinfo
-        else:
-            self.repoinfo = yumrepoinfo.get_yumrepoinfo()
-
+        self.repoinfo = repoinfo
 
     def process(self, input_data, env_data):
 
-        conf = config.get_config()
-
         if 'koji_tag' not in input_data or 'arch' not in input_data:
             raise TaskotronDirectiveError("The yumrepoinfo directive requires "\
                     "koji_tag and arch arguments.")
 
-        arch = input_data.get('arch', 'noarch')
+        arch = input_data['arch']
         koji_tag = input_data['koji_tag']
 
         output = {}
 
+        if self.repoinfo is None:
+            self.repoinfo = yumrepoinfo.get_yumrepoinfo(arch)
+
         if koji_tag.endswith('-pending'):
            koji_tag = koji_tag[:-len('-pending')]
 
diff --git a/testing/test_yumrepoinfo_directive.py b/testing/test_yumrepoinfo_directive.py
--- a/testing/test_yumrepoinfo_directive.py
+++ b/testing/test_yumrepoinfo_directive.py
@@ -1,6 +1,6 @@
 import pytest
 import StringIO
-import ConfigParser
+from dingus import Dingus
 
 from libtaskotron.directives import yumrepoinfo_directive
 from libtaskotron.exceptions import TaskotronDirectiveError
@@ -48,7 +48,8 @@
     def setup_class(cls):
         '''One-time class initialization'''
         # create YumRepoInfo initialized with TEST_CONF
-        cls.repoinfo = yumrepoinfo.YumRepoInfo(filelist=[])
+        cls.ref_arch = 'x86_64'
+        cls.repoinfo = yumrepoinfo.YumRepoInfo(filelist=[], arch=cls.ref_arch)
         cls.repoinfo.parser.readfp(StringIO.StringIO(TEST_CONF))
 
     def test_missing_kojitag(self):
@@ -100,4 +101,22 @@
                 "f20-updates": "http://download.fedoraproject.org/pub/fedora/linux/updates/20/x86_64",
                 }
 
+    def test_use_arch(self, monkeypatch):
+        """Make sure that the arch passed in as an arg is used to create the
+        yumrepoinfo object instead of falling back to the default system arch"""
+        ref_arch = 'i386'
+
+        stub_getrepoinfo = Dingus(return_value=self.repoinfo)
+        monkeypatch.setattr(yumrepoinfo, 'get_yumrepoinfo', stub_getrepoinfo)
+
+        # don't set the repoinfo object, we've stubbed out the code that would
+        # hit the filesystem, so it's not a risk here
+        directive = yumrepoinfo_directive.YumrepoinfoDirective()
+        ref_input = {"koji_tag": "f20-updates", "arch": ref_arch}
+
+        directive.process(ref_input, None)
+
+        # check the first arg of the first call to the stub object
+        assert stub_getrepoinfo.calls()[0][1][0] == ref_arch
+
 