diff --git a/templates b/templates
--- a/templates
+++ b/templates
@@ -1990,20 +1990,23 @@
                       name => "install_blivet_ext3",
                       settings => [
                         { key => "PARTITIONING", value => "custom_blivet_ext3" },
+                        { key => "POSTINSTALL", value => "disk_custom_ext3_postinstall" },
                         { key => "ROOT_PASSWORD", value => "weakpassword" },
                       ],
                     },
                     {
                       name => "install_blivet_no_swap",
                       settings => [
                         { key => "PARTITIONING", value => "custom_blivet_no_swap" },
+                        { key => "POSTINSTALL", value => "disk_custom_no_swap_postinstall" },
                         { key => "ROOT_PASSWORD", value => "weakpassword" },
                       ],
                     },
                     {
                       name => "install_blivet_xfs",
                       settings => [
                         { key => "PARTITIONING", value => "custom_blivet_xfs" },
+                        { key => "POSTINSTALL", value => "disk_custom_xfs_postinstall" },
                         { key => "ROOT_PASSWORD", value => "weakpassword" },
                       ],
                     },
@@ -2020,6 +2023,7 @@
                       name => "install_blivet_lvmthin",
                       settings => [
                         { key => "PARTITIONING", value => "custom_blivet_lvmthin" },
+                        { key => "POSTINSTALL", value => "disk_custom_lvmthin_postinstall" },
                         { key => "ROOT_PASSWORD", value => "weakpassword" },
                       ],
                     },
diff --git a/tests/disk_custom_software_raid_postinstall.pm b/tests/disk_custom_btrfs_postinstall.pm
copy from tests/disk_custom_software_raid_postinstall.pm
copy to tests/disk_custom_btrfs_postinstall.pm
--- a/tests/disk_custom_software_raid_postinstall.pm
+++ b/tests/disk_custom_btrfs_postinstall.pm
@@ -4,8 +4,8 @@
 
 sub run {
     assert_screen "root_console";
-    # check that RAID is used
-    validate_script_output "cat /proc/mdstat", sub { $_ =~ m/Personalities : \[raid1\]/ };
+    # check that btrfs is used on root partition
+    assert_script_run "mount | grep 'on / type btrfs'";
 }
 
 sub test_flags {
diff --git a/tests/disk_custom_software_raid_postinstall.pm b/tests/disk_custom_ext3_postinstall.pm
copy from tests/disk_custom_software_raid_postinstall.pm
copy to tests/disk_custom_ext3_postinstall.pm
--- a/tests/disk_custom_software_raid_postinstall.pm
+++ b/tests/disk_custom_ext3_postinstall.pm
@@ -4,8 +4,8 @@
 
 sub run {
     assert_screen "root_console";
-    # check that RAID is used
-    validate_script_output "cat /proc/mdstat", sub { $_ =~ m/Personalities : \[raid1\]/ };
+    # check that ext3 is used on root partition
+    assert_script_run "mount | grep 'on / type ext3'";
 }
 
 sub test_flags {
diff --git a/tests/disk_custom_lvmthin_postinstall.pm b/tests/disk_custom_lvmthin_postinstall.pm
new file mode 100644
--- /dev/null
+++ b/tests/disk_custom_lvmthin_postinstall.pm
@@ -0,0 +1,19 @@
+use base "installedtest";
+use strict;
+use testapi;
+
+sub run {
+    assert_screen "root_console";
+    # check that lvmthinpool is present:
+    # http://atodorov.org/blog/2015/04/14/how-to-find-if-lvm-volume-is-thinly-provisioned/
+    # arguments of thinpool devices has T, t or V at the beginning of attributes
+    assert_script_run "lvs -o lv_attr | grep -E '^[[:space:]]*(T|t|V)'";
+}
+
+sub test_flags {
+    return { fatal => 1 };
+}
+
+1;
+
+# vim: set sw=4 et:
diff --git a/tests/disk_custom_software_raid_postinstall.pm b/tests/disk_custom_no_swap_postinstall.pm
copy from tests/disk_custom_software_raid_postinstall.pm
copy to tests/disk_custom_no_swap_postinstall.pm
--- a/tests/disk_custom_software_raid_postinstall.pm
+++ b/tests/disk_custom_no_swap_postinstall.pm
@@ -4,8 +4,8 @@
 
 sub run {
     assert_screen "root_console";
-    # check that RAID is used
-    validate_script_output "cat /proc/mdstat", sub { $_ =~ m/Personalities : \[raid1\]/ };
+    # check that swap is not used, check that "swapon --show has empty input"
+    assert_script_run '[[ ! $(swapon --show) ]]';
 }
 
 sub test_flags {
diff --git a/tests/disk_custom_software_raid_postinstall.pm b/tests/disk_custom_software_raid_postinstall.pm
--- a/tests/disk_custom_software_raid_postinstall.pm
+++ b/tests/disk_custom_software_raid_postinstall.pm
@@ -5,7 +5,7 @@
 sub run {
     assert_screen "root_console";
     # check that RAID is used
-    validate_script_output "cat /proc/mdstat", sub { $_ =~ m/Personalities : \[raid1\]/ };
+    assert_script_run "cat /proc/mdstat | grep 'Personalities : \\\[raid1\\\]'";
 }
 
 sub test_flags {
diff --git a/tests/disk_custom_software_raid_postinstall.pm b/tests/disk_custom_xfs_postinstall.pm
copy from tests/disk_custom_software_raid_postinstall.pm
copy to tests/disk_custom_xfs_postinstall.pm
--- a/tests/disk_custom_software_raid_postinstall.pm
+++ b/tests/disk_custom_xfs_postinstall.pm
@@ -4,8 +4,8 @@
 
 sub run {
     assert_screen "root_console";
-    # check that RAID is used
-    validate_script_output "cat /proc/mdstat", sub { $_ =~ m/Personalities : \[raid1\]/ };
+    # check that xfs is used on root partition
+    assert_script_run "mount | grep 'on / type xfs'";
 }
 
 sub test_flags {