diff --git a/needles/anaconda/partitioning/blivet/anaconda_blivet_part_fs_btrfs-20170510.json b/needles/anaconda/partitioning/blivet/anaconda_blivet_part_fs_btrfs-20170510.json
new file mode 100644
--- /dev/null
+++ b/needles/anaconda/partitioning/blivet/anaconda_blivet_part_fs_btrfs-20170510.json
@@ -0,0 +1,15 @@
+{
+  "area": [
+    {
+      "xpos": 419,
+      "ypos": 197,
+      "width": 32,
+      "height": 18,
+      "type": "match"
+    }
+  ],
+  "properties": [],
+  "tags": [
+    "anaconda_blivet_part_fs_btrfs"
+  ]
+}
\ No newline at end of file
diff --git a/needles/anaconda/partitioning/blivet/anaconda_blivet_part_fs_btrfs-20170510.png b/needles/anaconda/partitioning/blivet/anaconda_blivet_part_fs_btrfs-20170510.png
new file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/blivet/anaconda_blivet_lvm_drive-20170420.json b/needles/anaconda/partitioning/blivet/anaconda_blivet_volumes_icon-20170420.json
rename from needles/anaconda/partitioning/blivet/anaconda_blivet_lvm_drive-20170420.json
rename to needles/anaconda/partitioning/blivet/anaconda_blivet_volumes_icon-20170420.json
--- a/needles/anaconda/partitioning/blivet/anaconda_blivet_lvm_drive-20170420.json
+++ b/needles/anaconda/partitioning/blivet/anaconda_blivet_volumes_icon-20170420.json
@@ -10,6 +10,6 @@
   ],
   "properties": [],
   "tags": [
-    "anaconda_blivet_lvm_drive"
+    "anaconda_blivet_volumes_icon"
   ]
-}
\ No newline at end of file
+}
diff --git a/needles/anaconda/partitioning/blivet/anaconda_blivet_lvm_drive-20170420.png b/needles/anaconda/partitioning/blivet/anaconda_blivet_volumes_icon-20170420.png
rename from needles/anaconda/partitioning/blivet/anaconda_blivet_lvm_drive-20170420.png
rename to needles/anaconda/partitioning/blivet/anaconda_blivet_volumes_icon-20170420.png
diff --git a/templates b/templates
--- a/templates
+++ b/templates
@@ -899,7 +899,7 @@
                     },
                     {
                       machine    => { name => "64bit" },
-                      prio       => 90,
+                      prio       => 40,
                       product    => {
                                       arch    => "x86_64",
                                       distri  => "fedora",
@@ -910,7 +910,18 @@
                     },
                     {
                       machine    => { name => "64bit" },
-                      prio       => 90,
+                      prio       => 40,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "universal",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "install_blivet_btrfs" },
+                    },
+                    {
+                      machine    => { name => "64bit" },
+                      prio       => 50,
                       product    => {
                                       arch    => "x86_64",
                                       distri  => "fedora",
@@ -921,7 +932,7 @@
                     },
                     {
                       machine    => { name => "64bit" },
-                      prio       => 90,
+                      prio       => 40,
                       product    => {
                                       arch    => "x86_64",
                                       distri  => "fedora",
@@ -932,7 +943,7 @@
                     },
                     {
                       machine    => { name => "64bit" },
-                      prio       => 90,
+                      prio       => 40,
                       product    => {
                                       arch    => "x86_64",
                                       distri  => "fedora",
@@ -943,7 +954,7 @@
                     },
                     {
                       machine    => { name => "64bit" },
-                      prio       => 90,
+                      prio       => 40,
                       product    => {
                                       arch    => "x86_64",
                                       distri  => "fedora",
@@ -1489,6 +1500,17 @@
                                       flavor  => "universal",
                                       version => "*",
                                     },
+                      test_suite => { name => "install_blivet_btrfs" },
+                    },
+                    {
+                      machine    => { name => "64bit" },
+                      prio       => 93,
+                      product    => {
+                                      arch    => "i386",
+                                      distri  => "fedora",
+                                      flavor  => "universal",
+                                      version => "*",
+                                    },
                       test_suite => { name => "install_blivet_no_swap" },
                     },
                     {
@@ -1995,6 +2017,14 @@
                       ],
                     },
                     {
+                      name => "install_blivet_btrfs",
+                      settings => [
+                        { key => "PARTITIONING", value => "custom_blivet_btrfs" },
+                        { key => "POSTINSTALL", value => "disk_custom_btrfs_postinstall" },
+                        { key => "ROOT_PASSWORD", value => "weakpassword" },
+                      ],
+                    },
+                    {
                       name => "install_blivet_no_swap",
                       settings => [
                         { key => "PARTITIONING", value => "custom_blivet_no_swap" },
diff --git a/tests/disk_custom_blivet_lvmthin.pm b/tests/disk_custom_blivet_btrfs.pm
copy from tests/disk_custom_blivet_lvmthin.pm
copy to tests/disk_custom_blivet_btrfs.pm
--- a/tests/disk_custom_blivet_lvmthin.pm
+++ b/tests/disk_custom_blivet_btrfs.pm
@@ -11,15 +11,13 @@
     assert_and_click "anaconda_spoke_done";
 
     custom_blivet_add_partition(size => 512, mountpoint => '/boot');
-    # add new LVM device
-    custom_blivet_add_partition(devicetype => 'lvm');
-    # select newly created LVM device for adding new partition
-    assert_and_click "anaconda_blivet_lvm_drive";
     custom_blivet_add_partition(size => 2048, filesystem => 'swap');
-    # add lvmthinpool
-    custom_blivet_add_partition(devicetype => 'lvmthin');
-    # select lvmthinpool for adding new partitions
-    assert_and_click "anaconda_blivet_thinpool_part";
+
+    # selecting "btrfs" as filesystem creates new BTRFS drive in blivet-gui
+    custom_blivet_add_partition(filesystem => 'btrfs');
+    # select newly created BTRFS drive (let's hope that BTRFS drive is only volume present)
+    assert_and_click "anaconda_blivet_volumes_icon";
+    # add root partition to btrfs drive
     custom_blivet_add_partition(mountpoint => '/');
 
     assert_and_click "anaconda_spoke_done";
diff --git a/tests/disk_custom_blivet_lvmthin.pm b/tests/disk_custom_blivet_lvmthin.pm
--- a/tests/disk_custom_blivet_lvmthin.pm
+++ b/tests/disk_custom_blivet_lvmthin.pm
@@ -14,7 +14,7 @@
     # add new LVM device
     custom_blivet_add_partition(devicetype => 'lvm');
     # select newly created LVM device for adding new partition
-    assert_and_click "anaconda_blivet_lvm_drive";
+    assert_and_click "anaconda_blivet_volumes_icon";
     custom_blivet_add_partition(size => 2048, filesystem => 'swap');
     # add lvmthinpool
     custom_blivet_add_partition(devicetype => 'lvmthin');