diff --git a/needles/anaconda/partitioning/blivet/anaconda_blivet_part_fs_efi_filesystem-20170518.json b/needles/anaconda/partitioning/blivet/anaconda_blivet_part_fs_efi_filesystem-20170518.json
new file mode 100644
--- /dev/null
+++ b/needles/anaconda/partitioning/blivet/anaconda_blivet_part_fs_efi_filesystem-20170518.json
@@ -0,0 +1,15 @@
+{
+  "area": [
+    {
+      "xpos": 413,
+      "ypos": 194,
+      "width": 118,
+      "height": 19,
+      "type": "match"
+    }
+  ],
+  "properties": [],
+  "tags": [
+    "anaconda_blivet_part_fs_efi_filesystem"
+  ]
+}
\ No newline at end of file
diff --git a/needles/anaconda/partitioning/blivet/anaconda_blivet_part_fs_efi_filesystem-20170518.png b/needles/anaconda/partitioning/blivet/anaconda_blivet_part_fs_efi_filesystem-20170518.png
new file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/templates b/templates
--- a/templates
+++ b/templates
@@ -964,6 +964,72 @@
                       test_suite => { name => "install_blivet_lvmthin" },
                     },
                     {
+                      machine    => { name => "uefi" },
+                      prio       => 41,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "universal",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "install_blivet_ext3" },
+                    },
+                    {
+                      machine    => { name => "uefi" },
+                      prio       => 41,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "universal",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "install_blivet_btrfs" },
+                    },
+                    {
+                      machine    => { name => "uefi" },
+                      prio       => 51,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "universal",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "install_blivet_no_swap" },
+                    },
+                    {
+                      machine    => { name => "uefi" },
+                      prio       => 41,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "universal",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "install_blivet_xfs" },
+                    },
+                    {
+                      machine    => { name => "uefi" },
+                      prio       => 41,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "universal",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "install_blivet_software_raid" },
+                    },
+                    {
+                      machine    => { name => "uefi" },
+                      prio       => 41,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "universal",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "install_blivet_lvmthin" },
+                    },
+                    {
                       machine    => { name => "64bit" },
                       prio       => 50,
                       product    => {
diff --git a/tests/disk_custom_blivet_btrfs.pm b/tests/disk_custom_blivet_btrfs.pm
--- a/tests/disk_custom_blivet_btrfs.pm
+++ b/tests/disk_custom_blivet_btrfs.pm
@@ -10,6 +10,11 @@
     select_disks();
     assert_and_click "anaconda_spoke_done";
 
+    if (get_var("UEFI")) {
+        # if we're running on UEFI, we need esp
+        custom_blivet_add_partition(size => 512, mountpoint => '/boot/efi', filesystem => 'efi_filesystem');
+    }
+
     custom_blivet_add_partition(size => 512, mountpoint => '/boot');
     custom_blivet_add_partition(size => 2048, filesystem => 'swap');
 
diff --git a/tests/disk_custom_blivet_ext3.pm b/tests/disk_custom_blivet_ext3.pm
--- a/tests/disk_custom_blivet_ext3.pm
+++ b/tests/disk_custom_blivet_ext3.pm
@@ -10,6 +10,11 @@
     select_disks();
     assert_and_click "anaconda_spoke_done";
 
+    if (get_var("UEFI")) {
+        # if we're running on UEFI, we need esp
+        custom_blivet_add_partition(size => 512, mountpoint => '/boot/efi', filesystem => 'efi_filesystem');
+    }
+
     custom_blivet_add_partition(size => 512, mountpoint => '/boot');
     custom_blivet_add_partition(size => 2048, filesystem => 'swap');
     custom_blivet_add_partition(filesystem => 'ext3', mountpoint => '/');
diff --git a/tests/disk_custom_blivet_lvmthin.pm b/tests/disk_custom_blivet_lvmthin.pm
--- a/tests/disk_custom_blivet_lvmthin.pm
+++ b/tests/disk_custom_blivet_lvmthin.pm
@@ -10,6 +10,11 @@
     select_disks();
     assert_and_click "anaconda_spoke_done";
 
+    if (get_var("UEFI")) {
+        # if we're running on UEFI, we need esp
+        custom_blivet_add_partition(size => 512, mountpoint => '/boot/efi', filesystem => 'efi_filesystem');
+    }
+
     custom_blivet_add_partition(size => 512, mountpoint => '/boot');
     # add new LVM device
     custom_blivet_add_partition(devicetype => 'lvm');
diff --git a/tests/disk_custom_blivet_no_swap.pm b/tests/disk_custom_blivet_no_swap.pm
--- a/tests/disk_custom_blivet_no_swap.pm
+++ b/tests/disk_custom_blivet_no_swap.pm
@@ -10,6 +10,11 @@
     select_disks();
     assert_and_click "anaconda_spoke_done";
 
+    if (get_var("UEFI")) {
+        # if we're running on UEFI, we need esp
+        custom_blivet_add_partition(size => 512, mountpoint => '/boot/efi', filesystem => 'efi_filesystem');
+    }
+
     custom_blivet_add_partition(size => 512, mountpoint => '/boot');
     custom_blivet_add_partition(mountpoint => '/');
 
diff --git a/tests/disk_custom_blivet_software_raid.pm b/tests/disk_custom_blivet_software_raid.pm
--- a/tests/disk_custom_blivet_software_raid.pm
+++ b/tests/disk_custom_blivet_software_raid.pm
@@ -10,6 +10,11 @@
     select_disks(disks=>2);
     assert_and_click "anaconda_spoke_done";
 
+    if (get_var("UEFI")) {
+        # if we're running on UEFI, we need esp
+        custom_blivet_add_partition(size => 512, mountpoint => '/boot/efi', filesystem => 'efi_filesystem');
+    }
+
     custom_blivet_add_partition(size => 512, mountpoint => '/boot');
     custom_blivet_add_partition(size => 2048, filesystem => 'swap');
     custom_blivet_add_partition(raid1 => 1, mountpoint => '/');
diff --git a/tests/disk_custom_blivet_xfs.pm b/tests/disk_custom_blivet_xfs.pm
--- a/tests/disk_custom_blivet_xfs.pm
+++ b/tests/disk_custom_blivet_xfs.pm
@@ -10,6 +10,11 @@
     select_disks();
     assert_and_click "anaconda_spoke_done";
 
+    if (get_var("UEFI")) {
+        # if we're running on UEFI, we need esp
+        custom_blivet_add_partition(size => 512, mountpoint => '/boot/efi', filesystem => 'efi_filesystem');
+    }
+
     custom_blivet_add_partition(size => 512, mountpoint => '/boot');
     custom_blivet_add_partition(size => 2048, filesystem => 'swap');
     custom_blivet_add_partition(filesystem => 'xfs', mountpoint => '/');